import { NumberValue, Schema, StringValue } from "@coveo/bueno";
import { LitElement, html } from "lit";
import { customElement, property, state } from "lit/decorators.js";
import { ValidatePropsController } from "../../common/validate-props-controller/validate-props-controller.js";
import { bindingGuard } from "../../../decorators/binding-guard.js";
import { bindings } from "../../../decorators/bindings.js";
import { errorGuard } from "../../../decorators/error-guard.js";
function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : null === desc ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if ("object" == typeof Reflect && "function" == typeof Reflect.decorate) r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if ("object" == typeof Reflect && "function" == typeof Reflect.metadata) return Reflect.metadata(k, v);
}
class AtomicText extends LitElement {
    get strings() {
        return {
            value: ()=>this.bindings.i18n.t(this.value, {
                    count: this.count
                })
        };
    }
    initialize() {}
    render() {
        return html`${this.strings.value()}`;
    }
    constructor(){
        super();
        new ValidatePropsController(this, ()=>({
                value: this.value,
                count: this.count
            }), AtomicText.propsSchema);
    }
}
AtomicText.propsSchema = new Schema({
    value: new StringValue({
        required: true,
        emptyAllowed: false
    }),
    count: new NumberValue({
        required: false
    })
});
_ts_decorate([
    state(),
    _ts_metadata("design:type", "u" < typeof Bindings ? Object : Bindings)
], AtomicText.prototype, "bindings", void 0);
_ts_decorate([
    state(),
    _ts_metadata("design:type", "u" < typeof Error ? Object : Error)
], AtomicText.prototype, "error", void 0);
_ts_decorate([
    property({
        type: String,
        reflect: true
    }),
    _ts_metadata("design:type", String)
], AtomicText.prototype, "value", void 0);
_ts_decorate([
    property({
        type: Number,
        reflect: true
    }),
    _ts_metadata("design:type", Number)
], AtomicText.prototype, "count", void 0);
_ts_decorate([
    bindingGuard(),
    errorGuard(),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", []),
    _ts_metadata("design:returntype", void 0)
], AtomicText.prototype, "render", null);
AtomicText = _ts_decorate([
    customElement('atomic-text'),
    bindings(),
    _ts_metadata("design:type", Function),
    _ts_metadata("design:paramtypes", [])
], AtomicText);
export { AtomicText };
